=== modified file 'examples/proxy.c'
--- examples/proxy.c	2010-09-28 07:50:05 +0000
+++ examples/proxy.c	2010-11-08 07:44:03 +0000
@@ -45,9 +45,9 @@
   drizzle_verbose_t verbose= DRIZZLE_VERBOSE_NEVER;
   drizzle_return_t ret;
   drizzle_st drizzle;
-  drizzle_con_st con_listen;
-  drizzle_con_st server;
-  drizzle_con_st client;
+  drizzle_con_st *con_listen= (drizzle_con_st*)malloc(sizeof(drizzle_con_st));
+  drizzle_con_st *server= (drizzle_con_st*)malloc(sizeof(drizzle_con_st));
+  drizzle_con_st *client= (drizzle_con_st*)malloc(sizeof(drizzle_con_st));
   drizzle_result_st server_result;
   drizzle_result_st client_result;
   drizzle_column_st column;
@@ -112,19 +112,19 @@
   drizzle_add_options(&drizzle, DRIZZLE_FREE_OBJECTS);
   drizzle_set_verbose(&drizzle, verbose);
 
-  if (drizzle_con_create(&drizzle, &con_listen) == NULL)
+  if (drizzle_con_create(&drizzle, con_listen) == NULL)
   {
     printf("drizzle_con_create:NULL\n");
     return 1;
   }
 
-  drizzle_con_add_options(&con_listen, DRIZZLE_CON_LISTEN);
-  drizzle_con_set_tcp(&con_listen, server_host, server_port);
+  drizzle_con_add_options(con_listen, DRIZZLE_CON_LISTEN);
+  drizzle_con_set_tcp(con_listen, server_host, server_port);
 
   if (server_mysql)
-    drizzle_con_add_options(&con_listen, DRIZZLE_CON_MYSQL);
+    drizzle_con_add_options(con_listen, DRIZZLE_CON_MYSQL);
 
-  if (drizzle_con_listen(&con_listen) != DRIZZLE_RETURN_OK)
+  if (drizzle_con_listen(con_listen) != DRIZZLE_RETURN_OK)
   {
     printf("drizzle_con_listen:%s\n", drizzle_error(&drizzle));
     return 1;
@@ -132,36 +132,36 @@
 
   while (1)
   {
-    (void)drizzle_con_accept(&drizzle, &server, &ret);
+    (void)drizzle_con_accept(&drizzle, server, &ret);
     if (ret != DRIZZLE_RETURN_OK)
     {
       printf("drizzle_con_accept:%s\n", drizzle_error(&drizzle));
       return 1;
     }
 
-    if (drizzle_con_create(&drizzle, &client) == NULL)
+    if (drizzle_con_create(&drizzle, client) == NULL)
     {
       printf("drizzle_con_create:NULL\n");
       return 1;
     }
 
-    drizzle_con_add_options(&client,
+    drizzle_con_add_options(client,
                             DRIZZLE_CON_RAW_PACKET | DRIZZLE_CON_RAW_SCRAMBLE);
     if (client_mysql)
-      drizzle_con_add_options(&client, DRIZZLE_CON_MYSQL);
-    drizzle_con_set_tcp(&client, client_host, client_port);
+      drizzle_con_add_options(client, DRIZZLE_CON_MYSQL);
+    drizzle_con_set_tcp(client, client_host, client_port);
 
-    ret= drizzle_con_connect(&client);
+    ret= drizzle_con_connect(client);
     if (ret != DRIZZLE_RETURN_OK)
     {
       printf("drizzle_con_connect:%s\n", drizzle_error(&drizzle));
       return 1;
     }
 
-    proxy(&drizzle, &server, &client, &server_result, &client_result, &column);
+    proxy(&drizzle, server, client, &server_result, &client_result, &column);
 
-    drizzle_con_free(&client);
-    drizzle_con_free(&server);
+    drizzle_con_free(client);
+    drizzle_con_free(server);
 
     if (count > 0)
     {
@@ -172,9 +172,13 @@
     }
   }
 
-  drizzle_con_free(&con_listen);
+  drizzle_con_free(con_listen);
   drizzle_free(&drizzle);
 
+  free(con_listen);
+  free(server);
+  free(client);
+
   return 0;
 }
 

